// -*- C++ -*-
/* 
 * File:   DataFormatBegin.inc
 * Author: denis
 *
 * Created on July 12, 2012, 8:02 AM
 */

#ifdef INITIALIZE_DEBUGGING_VARIABLES
#undef INITIALIZE_DEBUGGING_VARIABLES_TMP
#undef INITIALIZE_DEBUGGING_VARIABLES
#endif

#ifdef CURRENT_CLASS
#define INITIALIZE_DEBUGGING_VARIABLES_TMP(CLASS_VAR)                          \
                EXECUTE_ON_DEBUG(_dataFormatClassName   = #CLASS_VAR;    )     \
                EXECUTE_ON_DEBUG(_dataFormatConstructor = __PRETTY_FUNCTION__;)

#define INITIALIZE_DEBUGGING_VARIABLES INITIALIZE_DEBUGGING_VARIABLES_TMP(CURRENT_CLASS)
#endif


#ifdef LAST_CLASS_VERSION
    #ifdef CURRENT_CLASS_VERSION
    #error You cannot define LAST_CLASS_VERSION and CURRENT_CLASS_VERSION at the same time
    #endif

    #if   LAST_CLASS_VERSION == 0
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version0::CURRENT_CLASS
    #elif LAST_CLASS_VERSION == 1
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version1::CURRENT_CLASS
    #elif LAST_CLASS_VERSION == 2
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version2::CURRENT_CLASS
    #elif LAST_CLASS_VERSION == 3
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version3::CURRENT_CLASS
    #elif LAST_CLASS_VERSION == 4
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version4::CURRENT_CLASS
    #elif LAST_CLASS_VERSION == 5
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version5::CURRENT_CLASS
    #elif LAST_CLASS_VERSION == 6
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version6::CURRENT_CLASS
    #elif LAST_CLASS_VERSION == 7
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version7::CURRENT_CLASS
    #elif LAST_CLASS_VERSION == 8
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version8::CURRENT_CLASS
    #elif LAST_CLASS_VERSION == 9
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version9::CURRENT_CLASS
    #elif LAST_CLASS_VERSION == 10
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version10::CURRENT_CLASS
    #else
    #error Need to implement more versions in DataFormatLast
    #endif

    #define FULL_CURRENT_CLASS_NAME            CURRENT_CLASS


// LAST_VERSION is undefined. Means that CURRENT_CLASS_VERSION is defined
#else

    #ifndef CURRENT_CLASS_VERSION
    #error Either LAST_CLASS_VERSION or CURRENT_CLASS_VERSION needs to be defined
    #endif

    #if   CURRENT_CLASS_VERSION == 0
        #define VERSION_NAMESPACE                  version0
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::RawDAQData
    #elif CURRENT_CLASS_VERSION == 1
        #define VERSION_NAMESPACE                  version1
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version0::CURRENT_CLASS
    #elif CURRENT_CLASS_VERSION == 2
        #define VERSION_NAMESPACE                  version2
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version1::CURRENT_CLASS
    #elif CURRENT_CLASS_VERSION == 3
        #define VERSION_NAMESPACE                  version3
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version2::CURRENT_CLASS
    #elif CURRENT_CLASS_VERSION == 4
        #define VERSION_NAMESPACE                  version4
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version3::CURRENT_CLASS
    #elif CURRENT_CLASS_VERSION == 5
        #define VERSION_NAMESPACE                  version5
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version4::CURRENT_CLASS
    #elif CURRENT_CLASS_VERSION == 6
        #define VERSION_NAMESPACE                  version6
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version5::CURRENT_CLASS
    #elif CURRENT_CLASS_VERSION == 7
        #define VERSION_NAMESPACE                  version7
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version6::CURRENT_CLASS
    #elif CURRENT_CLASS_VERSION == 8
        #define VERSION_NAMESPACE                  version8
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version7::CURRENT_CLASS
    #elif CURRENT_CLASS_VERSION == 9
        #define VERSION_NAMESPACE                  version9
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version8::CURRENT_CLASS
    #elif CURRENT_CLASS_VERSION == 10
        #define VERSION_NAMESPACE                  version10
        #define PREVIOUS_VERSION_CLASS_NAME        daqdataformats::version9::CURRENT_CLASS
    #else
    #error Need to implement more versions in DataFormatLast
    #endif

    #define FULL_CURRENT_CLASS_NAME            VERSION_NAMESPACE::CURRENT_CLASS

#endif

