#include "DAQDataFormats/NOvACheckSum.h"

namespace daqdataformats {

    //--------------------------------------------------------------------------
    // Initialize the singleton pointer to NULL
    NOvACheckSum* NOvACheckSum::_instanceID = NULL;

    //--------------------------------------------------------------------------
    NOvACheckSum::NOvACheckSum(){}
    NOvACheckSum::~NOvACheckSum(){}

    //--------------------------------------------------------------------------
    /*! getInstance method returns the current instance if there is one
    or creates the initial instance if there is not one */
    NOvACheckSum* NOvACheckSum::getInstance(){
        if(_instanceID == NULL)	               // Check if there is an instance active
            _instanceID = new NOvACheckSum();  // If there is not, make a new one

        return _instanceID;
    }// end of NOvACheckSum::getInstance


    //--------------------------------------------------------------------------
    uint32_t NOvACheckSum::processCRC(void* buffer, uint32_t size){

        /// Reset _CRC32 object
        _CRC32.reset();
        /// Calculate CRC
        _CRC32.process_bytes((char*)buffer, size * 4);

        /// return it
        return _CRC32.checksum();
    }


}// end of daqdataformats namespace