#include <DatabaseUtils/DAQConfig/IDSpec.h>

namespace dbutils {
namespace daqconfig {

/**
 * Creates an ID-based configuration specification object from the
 * specified ID.  By default, new IDSpec instances are for global
 * DAQ configurations.
 *
 * @param configId The ID of the named configuration of interest.
 */
IDSpec::IDSpec(const int64_t& configId, CONFIG_LEVEL globalOrSubsystem,
               MAJOR_SYSTEM_TYPE daqOrSlowControls) : _configId(configId)
{
    _isSubsystemConfig = (globalOrSubsystem == SUBSYSTEM);
    _isSlowControlsConfig = (daqOrSlowControls == SLOWCONTROLS);
}

};  // end of namespace daqconfig
};  // end of namespace dbutils
